Bug 1818863

Summary: Running annocheck on guile .go file fails with coredump
Product: [Fedora] Fedora Reporter: Jan Pazdziora <jpazdziora>
Component: annobinAssignee: Nick Clifton <nickc>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: unspecified Docs Contact:
Priority: unspecified    
Version: 31CC: fweimer, jakub, jpazdziora, nickc
Target Milestone: ---   
Target Release: ---   
Hardware: Unspecified   
OS: Unspecified   
Whiteboard:
Fixed In Version: annobin-8.78-3.fc31 annobin-9.18-1.el7 Doc Type: No Doc Update
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2020-04-08 05:06:50 UTC Type: Bug
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:

Description Jan Pazdziora 2020-03-30 14:48:55 UTC
Description of problem:

Running annocheck on guile .go file fails with coredump.

Version-Release number of selected component (if applicable):

annobin-annocheck-8.78-2.fc31.x86_64
guile22-2.2.6-2.fc31.x86_64

How reproducible:

Deterministic.

Steps to Reproduce:
1. file /usr/lib64/guile/2.2/ccache/language/bytecode.go

/usr/lib64/guile/2.2/ccache/language/bytecode.go: ELF 64-bit LSB shared object, no machine, version 1 (embedded), dynamically linked, with debug_info, not stripped

2. /usr/bin/annocheck /usr/lib64/guile/2.2/ccache/language/bytecode.go

Actual results:

annocheck: Version 8.78.
Floating point exception (core dumped)

Expected results:

No FPE, no core dump.

Additional info:

The backtrace is

(gdb) bt
#0  0x000055efd5558ca5 in check_dynamic_section (data=0x7fffc16b0490, 
    data=0x7fffc16b0490, sec=0x7fffc16b04d0) at hardened.c:1366
#1  check_sec (data=0x7fffc16b0490, sec=0x7fffc16b04d0) at hardened.c:1366
#2  0x000055efd5550a00 in run_checkers (elf=0x55efd5c4a3c0, 
    fd=<optimized out>, 
    filename=0x7fffc16b237b "/usr/lib64/guile/2.2/ccache/language/bytecode.go")
    at annocheck.c:592
#3  process_elf (
    filename=0x7fffc16b237b "/usr/lib64/guile/2.2/ccache/language/bytecode.go", fd=<optimized out>, elf=0x55efd5c4a3c0) at annocheck.c:1281
#4  0x000055efd5550f21 in process_file (
    filename=0x7fffc16b237b "/usr/lib64/guile/2.2/ccache/language/bytecode.go")
    at annocheck.c:1469
#5  0x000055efd554f1c4 in process_files () at annocheck.c:1489
#6  main (argc=<optimized out>, argv=<optimized out>) at annocheck.c:1574

Comment 3 Nick Clifton 2020-03-30 16:17:26 UTC
Hi Jan,

  Sorry about that.  Annocheck was not expecting to find an empty dynamic section and so performed a division by zero.

  This should now be fixed in annobin-8.78-3.fc31, annobin-9.18-1.fc32 and annobin-9.18-1.fc33 and I will be creating a Bodhi request to push the updates once they are ready.

Cheers
  Nick

Comment 4 Fedora Update System 2020-03-30 16:22:54 UTC
FEDORA-2020-3e3d86cd47 has been submitted as an update to Fedora 31. https://bodhi.fedoraproject.org/updates/FEDORA-2020-3e3d86cd47

Comment 5 Fedora Update System 2020-03-30 16:22:57 UTC
FEDORA-2020-360405350a has been submitted as an update to Fedora 32. https://bodhi.fedoraproject.org/updates/FEDORA-2020-360405350a

Comment 6 Fedora Update System 2020-03-31 01:52:31 UTC
FEDORA-2020-360405350a has been pushed to the Fedora 32 testing repository.
In short time you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --advisory=FEDORA-2020-360405350a`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-360405350a

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 7 Fedora Update System 2020-03-31 02:25:38 UTC
FEDORA-2020-3e3d86cd47 has been pushed to the Fedora 31 testing repository.
In short time you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --advisory=FEDORA-2020-3e3d86cd47`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-3e3d86cd47

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 8 Fedora Update System 2020-03-31 02:46:57 UTC
FEDORA-EPEL-2020-ed756832ca has been pushed to the Fedora EPEL 7 testing repository.

You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2020-ed756832ca

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 9 Fedora Update System 2020-04-08 05:06:50 UTC
FEDORA-2020-3e3d86cd47 has been pushed to the Fedora 31 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 10 Fedora Update System 2020-04-15 22:03:06 UTC
FEDORA-EPEL-2020-ed756832ca has been pushed to the Fedora EPEL 7 stable repository.
If problem still persists, please make note of it in this bug report.